Utilities
Collaboration diagram for Utilities:

## Modules

| Parsing, Converting, and Comparing - Functions to Manipulate Sequence and Structure Strings
| Parsing, Converting, and Comparing - Functions to Manipulate Secondary Structures
| Various utilities for Sequence Alignments, and Comparative Structure Prediction
| Functions to Read/Write several File Formats for RNA Sequences, Structures, and Alignments
| Functions for Creating RNA Secondary Structures Plots, Dot-Plots, and More

## Files

file | alphabet.h
| Functions to process, convert, and generally handle different nucleotide and/or base pair alphabets.
file | utils.h
| General utility- and helper-functions used throughout the ViennaRNA Package.

## Macros

#define | VRNA_INPUT_ERROR 1U
| Output flag of get_input_line(): "An ERROR has occured, maybe EOF".
#define | VRNA_INPUT_QUIT 2U
| Output flag of get_input_line(): "the user requested quitting the program".
#define | VRNA_INPUT_MISC 4U
| Output flag of get_input_line(): "something was read".
#define | VRNA_INPUT_FASTA_HEADER 8U
| Input/Output flag of get_input_line(): if used as input option this tells get_input_line() that the data to be read should comply with the FASTA format. More...
#define | VRNA_INPUT_CONSTRAINT 32U
| Input flag for get_input_line(): Tell get_input_line() that we assume to read a structure constraint. More...
#define | VRNA_INPUT_NO_TRUNCATION 256U
| Input switch for get_input_line(): "do not trunkate the line by eliminating white spaces at end of line".
#define | VRNA_INPUT_NO_REST 512U
| Input switch for vrna_file_fasta_read_record(): "do fill rest array".
#define | VRNA_INPUT_NO_SPAN 1024U
| Input switch for vrna_file_fasta_read_record(): "never allow data to span more than one line".
#define | VRNA_INPUT_NOSKIP_BLANK_LINES 2048U
| Input switch for vrna_file_fasta_read_record(): "do not skip empty lines".
#define | VRNA_INPUT_BLANK_LINE 4096U
| Output flag for vrna_file_fasta_read_record(): "read an empty line".
#define | VRNA_INPUT_NOSKIP_COMMENTS 128U
| Input switch for get_input_line(): "do not skip comment lines".
#define | VRNA_INPUT_COMMENT 8192U
| Output flag for vrna_file_fasta_read_record(): "read a comment".
#define | MIN2(A, B) ((A) < (B) ? (A) : (B))
| Get the minimum of two comparable values.
#define | MAX2(A, B) ((A) > (B) ? (A) : (B))
| Get the maximum of two comparable values.
#define | MIN3(A, B, C) (MIN2( (MIN2((A),(B))) ,(C)))
| Get the minimum of three comparable values.
#define | MAX3(A, B, C) (MAX2( (MAX2((A),(B))) ,(C)))
| Get the maximum of three comparable values.

## Functions

void * | vrna_alloc (unsigned size)
| Allocate space safely. More...
void * | vrna_realloc (void *p, unsigned size)
| Reallocate space safely. More...
void | vrna_message_error (const char message[])
| Die with an error message. More...
void | vrna_message_warning (const char message[])
| Print a warning message. More...
void | vrna_init_rand (void)
| Initialize seed for random number generator.
double | vrna_urn (void)
| get a random number from [0..1] More...
int | vrna_int_urn (int from, int to)
| Generates a pseudo random integer in a specified range. More...
void | vrna_file_copy (FILE *from, FILE *to)
| Inefficient `cp'.
char * | vrna_time_stamp (void)
| Get a timestamp. More...
char * | get_line (FILE *fp)
| Read a line of arbitrary length from a stream. More...
unsigned int | get_input_line (char **string, unsigned int options)
void | vrna_message_input_seq_simple (void)
| Print a line to stdout that asks for an input sequence. More...
void | vrna_message_input_seq (const char *s)
| Print a line with a user defined string and a ruler to stdout. More...
int * | vrna_idx_row_wise (unsigned int length)
| Get an index mapper array (iindx) for accessing the energy matrices, e.g. in partition function related functions. More...
int * | vrna_idx_col_wise (unsigned int length)
| Get an index mapper array (indx) for accessing the energy matrices, e.g. in MFE related functions. More...

## Variables

unsigned short | xsubi [3]
| Current 48 bit random number. More...

## Detailed Description

## Macro Definition Documentation

#define VRNA_INPUT_FASTA_HEADER 8U

`#include <ViennaRNA/utils.h>`

Input/Output flag of get_input_line():
if used as input option this tells get_input_line() that the data to be read should comply with the FASTA format.

the function will return this flag if a fasta header was read

#define VRNA_INPUT_CONSTRAINT 32U

`#include <ViennaRNA/utils.h>`

Input flag for get_input_line():
Tell get_input_line() that we assume to read a structure constraint.

## Function Documentation

void* vrna_alloc | ( | unsigned | size | ) |

`#include <ViennaRNA/utils.h>`

Allocate space safely.

Parameters

  size | The size of the memory to be allocated in bytes

Returns
  A pointer to the allocated memory

void* vrna_realloc | ( | void * | p,
|  | unsigned | size
| ) |  |

`#include <ViennaRNA/utils.h>`

Reallocate space safely.

Parameters

  p | A pointer to the memory region to be reallocated
  size | The size of the memory to be allocated in bytes

Returns
  A pointer to the newly allocated memory

void vrna_message_error | ( | const char | message[] | ) |

`#include <ViennaRNA/utils.h>`

Die with an error message.

See also
  vrna_message_warning()

Parameters

  message | The error message to be printed before exiting with 'FAILURE'

void vrna_message_warning | ( | const char | message[] | ) |

`#include <ViennaRNA/utils.h>`

Print a warning message.

Print a warning message to stderr

Parameters

  message | The warning message

double vrna_urn | ( | void |  | ) |

`#include <ViennaRNA/utils.h>`

get a random number from [0..1]

See also
  vrna_int_urn(), vrna_init_rand()

Note
  Usually implemented by calling erand48().

Returns
  A random number in range [0..1]

int vrna_int_urn | ( | int | from,
|  | int | to
| ) |  |

`#include <ViennaRNA/utils.h>`

Generates a pseudo random integer in a specified range.

See also
  vrna_urn(), vrna_init_rand()

Parameters

  from | The first number in range
  to | The last number in range

Returns
  A pseudo random number in range [from, to]

char* vrna_time_stamp | ( | void |  | ) |

`#include <ViennaRNA/utils.h>`

Get a timestamp.

Returns a string containing the current date in the format

    Fri Mar 19 21:10:57 1993

Returns
  A string containing the timestamp

char* get_line | ( | FILE * | fp | ) |

`#include <ViennaRNA/utils.h>`

Read a line of arbitrary length from a stream.

Returns a pointer to the resulting string. The necessary memory is allocated and should be released using free() when the string is no longer needed.

Parameters

  fp | A file pointer to the stream where the function should read from

Returns
  A pointer to the resulting string

unsigned int get_input_line | ( | char ** | string,
|  | unsigned int | options
| ) |  |

`#include <ViennaRNA/utils.h>`

Retrieve a line from 'stdin' savely while skipping comment characters and other features This function returns the type of input it has read if recognized. An option argument allows to switch between different reading modes.
Currently available options are:
#VRNA_INPUT_NOPRINT_COMMENTS, VRNA_INPUT_NOSKIP_COMMENTS, #VRNA_INPUT_NOELIM_WS_SUFFIX

pass a collection of options as one value like this:

    get_input_line(string, option_1 | option_2 | option_n)

If the function recognizes the type of input, it will report it in the return value. It also reports if a user defined 'quit' command (-sign on 'stdin') was given. Possible return values are:
VRNA_INPUT_FASTA_HEADER, VRNA_INPUT_ERROR, VRNA_INPUT_MISC, VRNA_INPUT_QUIT

Parameters

  string | A pointer to the character array that contains the line read
  options | A collection of options for switching the functions behavior

Returns
  A flag with information about what has been read

void vrna_message_input_seq_simple | ( | void |  | ) |

`#include <ViennaRNA/utils.h>`

Print a line to stdout that asks for an input sequence.

There will also be a ruler (scale line) printed that helps orientation of the sequence positions

void vrna_message_input_seq | ( | const char * | s | ) |

`#include <ViennaRNA/utils.h>`

Print a line with a user defined string and a ruler to stdout.

(usually this is used to ask for user input) There will also be a ruler (scale line) printed that helps orientation of the sequence positions

Parameters

  s | A user defined string that will be printed to stdout

int* vrna_idx_row_wise | ( | unsigned int | length | ) |

`#include <ViennaRNA/utils.h>`

Get an index mapper array (iindx) for accessing the energy matrices, e.g. in partition function related functions.

Access of a position "(i,j)" is then accomplished by using

    (i,j) ~ iindx[i]-j

This function is necessary as most of the two-dimensional energy matrices are actually one-dimensional arrays throughout the ViennaRNA Package

Consult the implemented code to find out about the mapping formula ;)

See also
  vrna_idx_col_wise()

Parameters

  length | The length of the RNA sequence

Returns
  The mapper array

int* vrna_idx_col_wise | ( | unsigned int | length | ) |

`#include <ViennaRNA/utils.h>`

Get an index mapper array (indx) for accessing the energy matrices, e.g. in MFE related functions.

Access of a position "(i,j)" is then accomplished by using

    (i,j) ~ indx[j]+i

This function is necessary as most of the two-dimensional energy matrices are actually one-dimensional arrays throughout the ViennaRNAPackage

Consult the implemented code to find out about the mapping formula ;)

See also
  vrna_idx_row_wise()

Parameters

  length | The length of the RNA sequence

Returns
  The mapper array

## Variable Documentation

unsigned short xsubi[3]

`#include <ViennaRNA/utils.h>`

Current 48 bit random number.

This variable is used by vrna_urn(). These should be set to some random number seeds before the first call to vrna_urn().

See also
  vrna_urn()